"""initial version

Revision ID: e7e3cd09da52
Revises:
Create Date: 2021-12-13 08:19:22.019513+01:00

"""
import sqlalchemy as sa
from alembic import op
from alembic_utils.pg_function import PGFunction
from sqlalchemy.dialects import postgresql
from sqlalchemy.schema import CreateSequence, Sequence

# revision identifiers, used by Alembic.
revision = "e7e3cd09da52"
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # The next line is mannually added to make the sequence for the id
    op.execute(CreateSequence(Sequence("setting_id_seq")))

    # ### commands auto generated by Alembic - please adjust! ###
    public_setting_generate_id = PGFunction(
        schema="public",
        signature="setting_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'SET-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"setting_id_seq\"') INTO value_numeric;\n                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.create_entity(public_setting_generate_id)
    op.create_table(
        "SettingType",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_SettingType_name"), "SettingType", ["name"], unique=False)
    op.create_index(op.f("ix_SettingType_sid"), "SettingType", ["sid"], unique=False)
    op.create_table(
        "Setting",
        sa.Column("sid", sa.Integer(), nullable=False),
        sa.Column(
            "id",
            sa.String(),
            server_default=sa.text("setting_generate_id()"),
            nullable=False,
        ),
        sa.Column(
            "uuid",
            postgresql.UUID(as_uuid=True),
            server_default=sa.text("gen_random_uuid()"),
            nullable=False,
        ),
        sa.Column("name", sa.String(), nullable=True),
        sa.Column("value", sa.String(), nullable=True),
        sa.Column("description", sa.String(), nullable=True),
        sa.Column("regex", sa.String(), nullable=True),
        sa.Column("last_modified", sa.DateTime(), nullable=True),
        sa.Column("setting_type_id", sa.Integer(), nullable=False),
        sa.ForeignKeyConstraint(
            ["setting_type_id"],
            ["SettingType.sid"],
        ),
        sa.PrimaryKeyConstraint("sid"),
        sa.UniqueConstraint("uuid"),
    )
    op.create_index(op.f("ix_Setting_id"), "Setting", ["id"], unique=True)
    op.create_index(op.f("ix_Setting_name"), "Setting", ["name"], unique=False)
    op.create_index(
        op.f("ix_Setting_setting_type_id"),
        "Setting",
        ["setting_type_id"],
        unique=False,
    )
    op.create_index(op.f("ix_Setting_sid"), "Setting", ["sid"], unique=False)

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###

    op.drop_index(op.f("ix_Setting_sid"), table_name="Setting")
    op.drop_index(op.f("ix_Setting_setting_type_id"), table_name="Setting")
    op.drop_index(op.f("ix_Setting_name"), table_name="Setting")
    op.drop_index(op.f("ix_Setting_id"), table_name="Setting")
    op.drop_table("Setting")
    op.drop_index(op.f("ix_SettingType_sid"), table_name="SettingType")
    op.drop_index(op.f("ix_SettingType_name"), table_name="SettingType")
    op.drop_table("SettingType")

    public_setting_generate_id = PGFunction(
        schema="public",
        signature="setting_generate_id()",
        definition="RETURNS varchar\n        LANGUAGE plpgsql\n        AS $function$\n            DECLARE\n            v_result      varchar := 'SET-';\n            value_numeric numeric;\n            begin\n                SELECT nextval('\"setting_id_seq\"') INTO value_numeric;\n                IF value_numeric > 9999 THEN\n                    v_result := v_result || value_numeric;\n                ELSE\n                    v_result := v_result || to_char(value_numeric, 'FM0000');\n                END IF;\n                return v_result;\n            END;\n        $function$",  # noqa: E501
    )
    op.drop_entity(public_setting_generate_id)
    # ### end Alembic commands ###
